//------------------------------------------------------------------
#property copyright   "copyright mladen"
#property link        "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color3 clrSilver
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2
#property strict

enum enDisplayType
{
   dis_lines, // Display as colored lines
   dis_histo, // Display as colored histogram with colored lines
   dis_binary // Display as colored simple 0-1 histogram
};
extern int                CalcPeriod   = 50;           // Calculation period
extern ENUM_MA_METHOD     CalcMethod   = MODE_EMA;     // Calculation method
extern color              ColorUp      = clrLimeGreen; // Color up
extern color              ColorDown    = clrOrangeRed; // Color down
extern enDisplayType      DisplayAs    = dis_lines;    // Display as :

double ma[];
double mada[];
double madb[],avg[],histbu[],histbd[];
double slope[],prices[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{ 
   int lstyle = DRAW_LINE;      if (DisplayAs==dis_binary) lstyle = DRAW_NONE;
   int bstyle = DRAW_HISTOGRAM; if (DisplayAs==dis_lines)  bstyle = DRAW_NONE;
   IndicatorBuffers(8);
   SetIndexBuffer(0,histbu); SetIndexStyle(0,bstyle,EMPTY,EMPTY,ColorUp);
   SetIndexBuffer(1,histbd); SetIndexStyle(1,bstyle,EMPTY,EMPTY,ColorDown);
   SetIndexBuffer(2,avg);    SetIndexStyle(2,lstyle);
   SetIndexBuffer(3,ma);     SetIndexStyle(3,lstyle,EMPTY,EMPTY,ColorUp);
   SetIndexBuffer(4,mada);   SetIndexStyle(4,lstyle,EMPTY,EMPTY,ColorDown);
   SetIndexBuffer(5,madb);   SetIndexStyle(5,lstyle,EMPTY,EMPTY,ColorDown); 
   SetIndexBuffer(6,slope); 
   SetIndexBuffer(7,prices); 
   return(0); 
}
int deinit()
{
   return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start(void)
{    
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMin(Bars,Bars-1);
         
   //
   //
   //
   //
   //
   

   if (slope[limit]==-1) CleanPoint(limit,mada,madb);
   for (int i=limit; i>=0; i--)
   {
      avg[i]  = iMA(NULL,0,CalcPeriod,0,CalcMethod,PRICE_CLOSE,i);
      ma[i]   = Close[i]+Open[i]-2*avg[i]; avg[i] = Open[i]-avg[i];
      mada[i] = EMPTY_VALUE;
      madb[i] = EMPTY_VALUE;
      if (i<Bars-1) slope[i] = slope[i+1];
            if (ma[i]<0) slope[i] = -1;
            if (ma[i]>0) slope[i] =  1;
            if (DisplayAs!=dis_binary)
               if (slope[i]==-1) PlotPoint(i,mada,madb,ma);
            if (DisplayAs==dis_binary)
            {
               if (slope[i]== 1) { histbu[i] = 1; histbd[i] = 0; }
               if (slope[i]==-1) { histbd[i] = 1; histbu[i] = 0; }
               ma[i] = 0;
            }
            if (DisplayAs==dis_histo)
            {
               if (slope[i]== 1) { histbu[i] = ma[i]; histbd[i] = 0; }
               if (slope[i]==-1) { histbd[i] = ma[i]; histbu[i] = 0; }
            }
   }            
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>Bars-2) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>Bars-3) return;
   if (first[i+1] == EMPTY_VALUE)
         if (first[i+2] == EMPTY_VALUE) 
               { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
         else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else        { first[i]  = from[i];                          second[i] = EMPTY_VALUE; }
}